/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.cvut.fel.pjv.cars;

import cz.cvut.fel.pjv.cars.data.CarLinkedList;
import cz.cvut.fel.pjv.cars.data.RaceResult;
import cz.cvut.fel.pjv.cars.data.TimeSpan;
import cz.cvut.fel.pjv.cars.model.Car;
import cz.cvut.fel.pjv.cars.utils.ArrayUtil;

/**
 *
 * @author martin
 */
public class Race {

    private int length;
    private CarLinkedList cll;
    private RaceResult[] rr;
    private boolean isReady; //true .. zapis do zavodu, false .. zavod skoncil

    public Race(int length) {
        this.length = length;
        isReady = true;
        cll = new CarLinkedList();
    }

    public void addRacingCar(Car car) {
        cll.add(car);
    }

    private RaceResult[] getRaceResults() {
        if (isReady) {
            isReady = false;
            //vypocitat vysledky:

            rr = new RaceResult[cll.getNumCars()];              
            Car[] cars = cll.toArray();
            for (int i = 0; i < rr.length; i++) {
                rr[i] = new RaceResult(cars[i],
                        new TimeSpan(this.length / cars[i].getSpeed())
                );
            }
            ArrayUtil.sort(rr);

        }
        return rr;
    }

    public Car getWinner() {
        getRaceResults();
        return rr[0].car;
    }

    public TimeSpan getWinningTime() {
        getRaceResults();
        return rr[0].ts;
    }

    @Override
    public String toString() {
        String res = "";
        if (isReady) {
            // vypsat startovni listinu CLL
            Car[] cars = cll.toArray();
            for (int i = 0; i < cars.length; i++) {
                res += cars[i].toString() + "\n";
            }

        } else {
            // vypsat vysledkovou listinu RaceResult[]
            for (int i = 0; i < rr.length; i++) {
                res += rr[i].car.toString() + " ---- " + rr[i].ts.toString() + "\n";
            }
        }
        return res;
    }

}
