/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.cvut.fel.pjv.cars.model;

import java.util.Objects;

/**
 *
 * @author martin
 */
public class Car {
 
    private String manufacturer;
    private String modelName;
    private int year;
    private java.util.UUID vinCode;
    private static int numCars=0;
    private Engine engine;
    private ServiceBook sb;
    private int speed;

    public void setSb(ServiceBook sb) {
        if (this.sb==null){
            this.sb = sb;
        }
    }

    public ServiceBook getServiceBook() {
        return sb;
    }

    public int getSpeed() {
        return speed;
    }
    
    
    public Car(String manufacturer, String modelName, int year, String engineType, int speed) {
        this.manufacturer = manufacturer;
        this.modelName = modelName;
        this.year = year;
        vinCode=java.util.UUID.randomUUID();
        this.engine=new Engine(engineType);
        this.sb=null;
        this.speed=speed;
        numCars++;
    }

    @Override
    public String toString() {
        return manufacturer + " " + modelName + " year " + year + " VIN:" + vinCode;
    }

    public String getManufacturer() {
        return manufacturer;
    }

    public String getModelName() {
        return modelName;
    }

    public int getYear() {
        return year;
    }

   public static int getNumberOfExistingCars(){
       return numCars;
   }

    @Override
    public int hashCode() {
        int hash = 7;
        hash = 43 * hash + Objects.hashCode(this.vinCode);
        return hash;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final Car other = (Car) obj;
        //--------------------------
        if (!Objects.equals(this.vinCode, other.vinCode)) {
            return false;
        }
        if (this.year!=other.year) return false;
        
        return true;
    }   
    
}
